diff mbox

[v3,3/5] block: qemu-iotests - test for live migration

Message ID 4a81ae637219f8cbca5546ec21e3314e39bfa872.1397162006.git.jcody@redhat.com
State New
Headers show

Commit Message

Jeff Cody April 10, 2014, 8:47 p.m. UTC
This is an initial, simple live migration test from one
running VM to another, using monitor commands.

This is also an example on using the new common.qemu functions
for controlling multiple running qemu instances, for tests that
need a live qemu vm.

Signed-off-by: Jeff Cody <jcody@redhat.com>
---
 tests/qemu-iotests/090     | 97 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/090.out | 20 ++++++++++
 tests/qemu-iotests/group   |  1 +
 3 files changed, 118 insertions(+)
 create mode 100755 tests/qemu-iotests/090
 create mode 100644 tests/qemu-iotests/090.out

Comments

Kevin Wolf April 29, 2014, 2:15 p.m. UTC | #1
Am 10.04.2014 um 22:47 hat Jeff Cody geschrieben:
> This is an initial, simple live migration test from one
> running VM to another, using monitor commands.
> 
> This is also an example on using the new common.qemu functions
> for controlling multiple running qemu instances, for tests that
> need a live qemu vm.
> 
> Signed-off-by: Jeff Cody <jcody@redhat.com>
> ---
>  tests/qemu-iotests/090     | 97 ++++++++++++++++++++++++++++++++++++++++++++++
>  tests/qemu-iotests/090.out | 20 ++++++++++
>  tests/qemu-iotests/group   |  1 +
>  3 files changed, 118 insertions(+)
>  create mode 100755 tests/qemu-iotests/090
>  create mode 100644 tests/qemu-iotests/090.out
> 
> diff --git a/tests/qemu-iotests/090 b/tests/qemu-iotests/090
> new file mode 100755
> index 0000000..22a7cf1
> --- /dev/null
> +++ b/tests/qemu-iotests/090
> @@ -0,0 +1,97 @@
> +#!/bin/bash
> +#
> +# Live migration test
> +#
> +# Performs a migration from one VM to another via monitor commands
> +#
> +# Copyright (C) 2014 Red Hat, Inc.
> +#
> +# This program is free software; you can redistribute it and/or modify
> +# it under the terms of the GNU General Public License as published by
> +# the Free Software Foundation; either version 2 of the License, or
> +# (at your option) any later version.
> +#
> +# This program is distributed in the hope that it will be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program.  If not, see <http://www.gnu.org/licenses/>.
> +#
> +
> +# creator
> +owner=jcody@redhat.com
> +
> +seq=`basename $0`
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +status=1	# failure is the default!
> +
> +MIG_FIFO="${TEST_DIR}/migrate"
> +
> +_cleanup()
> +{
> +    rm -f "${MIG_FIFO}"
> +    _cleanup_qemu
> +	_cleanup_test_img
> +
> +}

There's a tab and an odd empty line in this function.

> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +# get standard environment, filters and checks
> +. ./common.rc
> +. ./common.filter
> +. ./common.qemu
> +
> +_supported_fmt qcow2
> +_supported_proto file
> +_supported_os Linux
> +
> +size=1G
> +
> +IMGOPTS="cluster_size=512" _make_test_img $size
> +
> +mkfifo "${MIG_FIFO}"
> +
> +echo
> +echo === Starting QEMU VM1 ===
> +echo
> +
> +qemu_comm_method="monitor"
> +_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk
> +h1=$QEMU_HANDLE
> +
> +echo
> +echo === Starting QEMU VM2 ===
> +echo
> +_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk \
> +             -incoming "exec: cat '${MIG_FIFO}'"
> +h2=$QEMU_HANDLE
> +
> +echo
> +echo === VM 1: Migrate from VM1 to VM2  ===
> +echo
> +
> +silent=yes
> +_send_qemu_cmd $h1 'qemu-io disk "write 0 4M"' "(qemu)"
> +echo "vm1: qemu-io disk write complete"
> +_send_qemu_cmd $h1 "migrate \"exec: cat > '${MIG_FIFO}'\"" "(qemu)"
> +echo "vm1: live migration started"
> +qemu_cmd_repeat=20 _send_qemu_cmd $h1 "info migrate" "completed"
> +echo "vm1: live migration completed"
> +
> +echo
> +echo === VM 2: Post-migration, write to disk, verify running ===
> +echo
> +
> +_send_qemu_cmd $h2 'qemu-io disk "write 4M 1M"' "(qemu)"
> +echo "vm2: qemu-io disk write complete"
> +qemu_cmd_repeat=20 _send_qemu_cmd $h2 "info status" "running"
> +echo "vm2: qemu process running successfully"

I think we should (cleanly) shut down qemu at this point and then run a
final qemu-img check.

Kevin
diff mbox

Patch

diff --git a/tests/qemu-iotests/090 b/tests/qemu-iotests/090
new file mode 100755
index 0000000..22a7cf1
--- /dev/null
+++ b/tests/qemu-iotests/090
@@ -0,0 +1,97 @@ 
+#!/bin/bash
+#
+# Live migration test
+#
+# Performs a migration from one VM to another via monitor commands
+#
+# Copyright (C) 2014 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=jcody@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1	# failure is the default!
+
+MIG_FIFO="${TEST_DIR}/migrate"
+
+_cleanup()
+{
+    rm -f "${MIG_FIFO}"
+    _cleanup_qemu
+	_cleanup_test_img
+
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+. ./common.qemu
+
+_supported_fmt qcow2
+_supported_proto file
+_supported_os Linux
+
+size=1G
+
+IMGOPTS="cluster_size=512" _make_test_img $size
+
+mkfifo "${MIG_FIFO}"
+
+echo
+echo === Starting QEMU VM1 ===
+echo
+
+qemu_comm_method="monitor"
+_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk
+h1=$QEMU_HANDLE
+
+echo
+echo === Starting QEMU VM2 ===
+echo
+_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk \
+             -incoming "exec: cat '${MIG_FIFO}'"
+h2=$QEMU_HANDLE
+
+echo
+echo === VM 1: Migrate from VM1 to VM2  ===
+echo
+
+silent=yes
+_send_qemu_cmd $h1 'qemu-io disk "write 0 4M"' "(qemu)"
+echo "vm1: qemu-io disk write complete"
+_send_qemu_cmd $h1 "migrate \"exec: cat > '${MIG_FIFO}'\"" "(qemu)"
+echo "vm1: live migration started"
+qemu_cmd_repeat=20 _send_qemu_cmd $h1 "info migrate" "completed"
+echo "vm1: live migration completed"
+
+echo
+echo === VM 2: Post-migration, write to disk, verify running ===
+echo
+
+_send_qemu_cmd $h2 'qemu-io disk "write 4M 1M"' "(qemu)"
+echo "vm2: qemu-io disk write complete"
+qemu_cmd_repeat=20 _send_qemu_cmd $h2 "info status" "running"
+echo "vm2: qemu process running successfully"
+
+
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/090.out b/tests/qemu-iotests/090.out
new file mode 100644
index 0000000..e965dfd
--- /dev/null
+++ b/tests/qemu-iotests/090.out
@@ -0,0 +1,20 @@ 
+QA output created by 090
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1073741824 
+
+=== Starting QEMU VM1 ===
+
+
+=== Starting QEMU VM2 ===
+
+
+=== VM 1: Migrate from VM1 to VM2 ===
+
+vm1: qemu-io disk write complete
+vm1: live migration started
+vm1: live migration completed
+
+=== VM 2: Post-migration, write to disk, verify running ===
+
+vm2: qemu-io disk write complete
+vm2: qemu process running successfully
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index 864643d..4386008 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -95,3 +95,4 @@ 
 086 rw auto quick
 087 rw auto
 088 rw auto
+090 rw auto